#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>

static float
f(int start, int end, const float *v1, const float *v2)
{
	int		 i;
	float		 res;

	for (res = 0.0, i = start; i < end; i++) 
		res += v1[i] * v2[i];

	return(res);
}

int
main(int argc, char *argv[])
{
	float *v1, *v2, rres, res;
	int i, sz = 50000000, rank, size, start, end;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	v1 = calloc(sz, sizeof(float));
	v2 = calloc(sz, sizeof(float));

	for (i = 0; i < sz; i++)
		v1[i] = v2[i] = (float)i;

	start = (rank * sz) / size;
	end = (rank == size - 1) ? sz : start + (sz / size);
	res = f(start, end, v1, v2);

	MPI_Reduce(&res, &rres, 1, MPI_FLOAT, MPI_SUM, 0, MPI_COMM_WORLD);

	if (0 == rank)
		printf("%g\n", rres);

	MPI_Finalize();
	return(EXIT_SUCCESS);
}
